package com.dayou.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dayou.common.RestResponse;
import com.dayou.entity.PostCultivate;
import com.dayou.service.IPostCultivateService;
import com.dayou.vo.PostCultivateVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 岗位培育关系
 *
 * @author wucl
 * @since 2023-01-10
 */
@RestController
@RequestMapping("postCultivate")
@Slf4j
public class PostCultivateController {

    @Autowired
    private IPostCultivateService postCultivateService;

    /**
     * 岗位培育关系
     */
    @GetMapping("")
    public RestResponse<Page<PostCultivateVO>> page(PostCultivateVO postCultivateVO, Page page){
        Page<PostCultivateVO> xPage = postCultivateService.getPage(page,postCultivateVO);
        return RestResponse.data(xPage);
    }

    /**
     * 新增培育关系
     * @param postCultivate
     * @return
     */
    @PostMapping("")
    public RestResponse<Boolean> add(@RequestBody PostCultivate postCultivate){
        Boolean ret = postCultivateService.save(postCultivate);
        return RestResponse.data(ret);
    }

    /**
     * 修改培育关系
     * @param postCultivate
     * @return
     */
    @PutMapping("")
    public RestResponse<Boolean> update(@RequestBody PostCultivate postCultivate){
        boolean update = postCultivateService.update(postCultivate);
        return RestResponse.data(update);
    }

    /**
     * 删除培育关系
     */
    @DeleteMapping("/{id}")
    public RestResponse<Boolean> delete(@PathVariable Long id) {
        Boolean ret = postCultivateService.delete(id);
        return RestResponse.data(ret);
    }
}
