package com.dayou.service.impl;

import com.dayou.entity.Post;
import com.dayou.entity.PostCultivate;
import com.dayou.mapper.PostCultivateMapper;
import com.dayou.service.IPostCultivateService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dayou.service.IPostService;
import com.dayou.utils.LoginContext;
import com.dayou.vo.PostCultivateVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dayou.utils.ExcelUtil;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.web.multipart.MultipartFile;
import java.util.List;
import java.util.ArrayList;
import java.util.Optional;

import org.springframework.transaction.annotation.Transactional;
import com.dayou.enums.BatchTaskTypeEnum;

import static com.dayou.common.Constants.SUPERVISOR;

/**
 * <p>
 * 岗位培育关系 服务实现类
 * </p>
 *
 * @author wucl
 * @since 2023-04-06
 */
@Service
public class PostCultivateServiceImpl extends ServiceImpl<PostCultivateMapper, PostCultivate> implements IPostCultivateService {


    @Autowired
    private IPostService postService;

    @Autowired
    private PostCultivateMapper postCultivateMapper;

    @Override
    public Integer countCultivate(String postName,Long userId) {
        Post post = postService.getOne(new LambdaQueryWrapper<Post>().eq(Post::getName, postName));
        return  this.count(new LambdaQueryWrapper<PostCultivate>().eq(PostCultivate::getParentUserId, userId).eq(PostCultivate::getUserPostId, post.getId()));
    }

    @Override
    public Page<PostCultivateVO> getPage(Page page, PostCultivateVO postCultivateVO) {
        Page<PostCultivateVO>  xPage = postCultivateMapper.getPage(page,postCultivateVO);
        return xPage;
    }

    @Override
    public Boolean update(PostCultivate postCultivate) {
        return this.updateById(postCultivate);
    }

    @Override
    public Boolean delete(Long id) {
        return this.removeById(id);
    }
}
